tmp<fv::convectionScheme<scalar> > mvConvection
(
    fv::convectionScheme<scalar>::New
    (
        mesh,
        fields,
        phi,
        mesh.divScheme("div(phi,Yj_h)")
    )
);

{
    reaction.correct();
    dQ = reaction.dQ();
    label explicitIndex = -1;
    volScalarField Yt(0.0*Y[0]);

    forAll(Y, j)
    {
        if (Y[j].name() != explicitSpecie)
        {
            volScalarField& Yj = Y[j];
            
            fvScalarMatrix YjEqn
            (
                fvm::ddt(rho, Yj)
              + mvConvection->fvmDiv(phi, Yj)
              - fvm::laplacian(diffusionCoeff.effDiff(Yj.name()), Yj)
             ==
                reaction.R(Yj)
              + membranesSpeciesMassFlux[j]
              + fvOptions(rho, Yj)
            );
            
            YjEqn.relax();

            fvOptions.constrain(YjEqn);

            YjEqn.solve(mesh.solver("Yj"));

            fvOptions.correct(Yj);

            Yj.max(0.0);
            Yt += Yj;
        }
        else
        {
            explicitIndex = j;
        }
    }
    Y[explicitIndex] = scalar(1) - Yt;
    Y[explicitIndex].max(0.0);
}
