bool convergency = true;

bool convergencyCheck(readBool(runTime.controlDict().lookup("convergencyCheck")));

if (convergencyCheck)
{
    scalar tolerance (readScalar(runTime.controlDict().lookup("tolerance")));
    
    Info << endl;

    forAll(regions, i)
    {
        rhoReactionThermo& thermo = chemistryFluid[i].thermo();
        thermo.validate(args.executable(), "h", "e");
        basicMultiComponentMixture& composition = thermo.composition();
        PtrList<volScalarField>& Y = composition.Y();
        
        scalar residualSum = 0.0;

        forAll(Y, j)
        {
            volScalarField specieResidual = mag(Y[j] - Y[j].prevIter());
            scalar specieResidualSum = gSum(specieResidual);
            reduce(specieResidualSum, sumOp<scalar>());
            residualSum += specieResidualSum;
        }

        Info << "Cumulative species residual for region " 
             << regions[i].name() << " = " << residualSum << endl;

        if (residualSum > tolerance)
        {
            convergency = false;
        }
    }

    if (convergency)
    {
        Info << "\nSolution is converged!!!\n" << endl;
        runTime.writeAndEnd();
    }
}