PtrList<volScalarField> rDeltaTFluid(regions.size());
int count(0);

forAll(regions, i)
{
    if(fv::localEulerDdt::enabled(regions[i]))
    {
        rDeltaTFluid.set
        (
            i,
            new volScalarField
            (
                IOobject
                (
                    "rDeltaT",
                    runTime.timeName(),
                    regions[i],
                    IOobject::READ_IF_PRESENT,
                    IOobject::AUTO_WRITE
                ),
                regions[i],
                dimensionedScalar("one", dimless/dimTime, 1),
                extrapolatedCalculatedFvPatchScalarField::typeName
            )
        );

        count++;
    }
}

bool LTS(false);

if(count == 0)
{
    LTS = false;
}
else if(count == regions.size())
{
    LTS = true;
    Info<< "Using LTS\n" << endl;
}
else
{
    FatalErrorInFunction
        << "All of the regions should be set to transient or steadystate! " << endl;

    forAll(regions, i)
    {
        if(fv::localEulerDdt::enabled(regions[i]))
        {
            FatalErrorInFunction << regions[i].name() << ": Steadystate" << endl;
        }
        else
        {
            FatalErrorInFunction << regions[i].name() << ": Transient" << endl;
        }
    }

    Info << exit(FatalError);
}
