forAll(regions, regioni)
{
	membranesMassFluxFluid[regioni] *= 0.0;
	membranesEnthalpyFluxFluid[regioni] *= 0.0;

	IOdictionary membraneDict
    (
        IOobject
        (
            "membraneProperties",
            runTime.time().constant(),
            regions[regioni],
            IOobject::MUST_READ_IF_MODIFIED,
            IOobject::NO_WRITE
        )
    );

    wordList membranesList
    (
        membraneDict.lookup("membranes")
    );

    forAll(membranesList, membranei)
    {	
    	membraneModel& membrane = membranesFluid[regioni][membranei];
    
        PtrList<volScalarField>& Y = chemistryFluid[regioni].thermo().composition().Y();
    
        forAll(Y, speciei)
        {        	
            //- Trans-membrane flux per specie
            membranesSpeciesMassFluxFluid[regioni][speciei] 
           = 
          	membrane.specieMassFlux(speciei);

          	//- Overall trans-membrane flux
            membranesMassFluxFluid[regioni] 
          += 
          	membranesSpeciesMassFluxFluid[regioni][speciei];

          	//- Overall enthalphy flux
            membranesEnthalpyFluxFluid[regioni] 
          += 
          	membrane.specieEnthalpyFlux
          	(
          		speciei,
          		membranesSpeciesMassFluxFluid[regioni][speciei]
          	);
        }
    }
}
