    fvMesh& mesh = regions[i];    

    combustionModels::rhoCombustionModel& reaction = chemistryFluid[i];
    rhoReactionThermo& thermo = chemistryFluid[i].thermo();

    thermo.validate(args.executable(), "h", "e");

    basicMultiComponentMixture& composition = thermo.composition();

    PtrList<volScalarField>& Y = composition.Y();

    word explicitSpecie(thermo.lookup("explicitSpecie"));

    volScalarField& rho = rhoFluid[i];
    volVectorField& U = UFluid[i];
    surfaceScalarField& phi = phiFluid[i];

     //set the turbulence into the adsorption model
    compressible::turbulenceModel& turb = turbulence[i];
    reaction.setTurbulence(turb);
    volScalarField& K = KFluid[i];
    volScalarField& dpdt = dpdtFluid[i];

    volScalarField& p = thermo.p();
    const volScalarField& psi = thermo.psi();

    volScalarField& p_rgh = p_rghFluid[i];

    const volScalarField& gh = ghFluid[i];
    const surfaceScalarField& ghf = ghfFluid[i];

    multivariateSurfaceInterpolationScheme<scalar>::fieldTable fields;

    forAll(Y, j)
    {
        fields.add(Y[j]);
    }
    fields.add(thermo.he());

    volScalarField dQ
    (
        IOobject
        (
            "dQ",
            runTime.timeName(),
            mesh
        ),
        mesh,
        dimensionedScalar
        (
            "dQ", 
            dimEnergy/dimTime, 
            0.0
        )
    );

    radiation::radiationModel& rad = radiation[i];

    fv::options& fvOptions = fluidFvOptions[i];

    const dimensionedScalar initialMass
    (
        "initialMass",
        dimMass,
        initialMassFluid[i]
    );

    diffusionModel& diffusionCoeff = diffusionCoeffFluid[i];

    PtrList<volScalarField>& membranesSpeciesMassFlux = membranesSpeciesMassFluxFluid[i];
    volScalarField& membranesMassFlux = membranesMassFluxFluid[i];
    volScalarField& membranesEnthalpyFlux = membranesEnthalpyFluxFluid[i];